/*
 * File metadata formatting.
 *
 * Copyright (C) 2019 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include "format.h"



/* Return the permissions of an object as a string. */

char *get_permission_string(uint16_t permissions)
{ 
  static char s[9] = "--------\0";
  static char letters[] = "rwx";
  int i, letter;
  uint16_t selector = 0400;

  for (i = 0, letter = 0; i < 9; i++, letter = (letter + 1) % 3, selector >>= 1)
    s[i] = permissions & selector ? letters[letter] : '-';

  return s;
}
